local L = AceLibrary("AceLocale-2.2"):new("HealerButtons")

HealerButtons = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0", "FuBarPlugin-2.0")
local dewdrop = AceLibrary("Dewdrop-2.0")
local msg = "old"

HealerButtons.bandages = {
	Linen					= L["Linen Bandage"],
	HeavyLinen				= L["Heavy Linen Bandage"],
	Wool					= L["Wool Bandage"],
	HeavyWool				= L["Heavy Wool Bandage"],
	Silk					= L["Silk Bandage"],
	HeavySilk				= L["Heavy Silk Bandage"],
	Mageweave				= L["Mageweave Bandage"],
	HeavyMageweave			= L["Heavy Mageweave Bandage"],
	Runecloth				= L["Runecloth Bandage"],
	HeavyRunecloth			= L["Heavy Runecloth Bandage"],
	HighlandersRunecloth	= L["Highlander's Runecloth Bandage"],
	HighlandersMageweave	= L["Highlander's Mageweave Bandage"],
	HighlandersSilk			= L["Highlander's Silk Bandage"],
	DefilersRunecloth		= L["Defiler's Runecloth Bandage"],
	DefilersMageweave		= L["Defiler's Mageweave Bandage"],
	DefilersSilk			= L["Defiler's Silk Bandage"],
	ABRunecloth				= L["Arathi Basin Runecloth Bandage"],
	ABMageweave				= L["Arathi Basin Mageweave Bandage"],
	ABSilk					= L["Arathi Basin Silk Bandage"],
	WSGRunecloth			= L["Warsong Gulch Runecloth Bandage"],
	WSGMageweave 			= L["Warsong Gulch Mageweave Bandage"],
	WSGSilk					= L["Warsong Gulch Silk Bandage"],
	AVHeavyRunecloth		= L["Alterac Heavy Runecloth Bandage"],
	Netherweave				= L["Netherweave Bandage"],
	HeavyNetherweave		= L["Heavy Netherweave Bandage"]
}

HealerButtons.bandageInfo = {
	[HealerButtons.bandages.Linen]				= {Level=1, HealAmount=66, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.HeavyLinen]			= {Level=1, HealAmount=114, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.Wool]				= {Level=1, HealAmount=161, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.HeavyWool]			= {Level=1, HealAmount=301, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.Silk]				= {Level=1, HealAmount=400, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.HeavySilk]			= {Level=1, HealAmount=640, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.Mageweave]			= {Level=1, HealAmount=800, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.HeavyMageweave]		= {Level=1, HealAmount=1104, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.Runecloth]			= {Level=52,HealAmount=1360, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.HeavyRunecloth]		= {Level=58,HealAmount=2000, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.Netherweave]		= {Level=64,HealAmount=2800, OnHand = 0, Bag = -1, Slot = 0},
	[HealerButtons.bandages.HeavyNetherweave]	= {Level=70,HealAmount=3400, OnHand = 0, Bag = -1, Slot = 0}
}

local menu = {
	type = "group",
	args = {
		Player = {
			type = "text",
			name = "Player Frame",
			desc = "Select which player frame support to use",
			validate = {"Blizzard", "XPerl", "Ag_UnitFrames"},
			get = "GetPlayerframe",
			set = "SetPlayerframe",
			order = 1,
		},
		
		Party = {
			type = "text",
			name = "Party Frame",
			desc = "Select which Party frame support to use",
			validate = {"Blizzard", "XPerl", "Ag_UnitFrames"},
			get = "GetPartyframe",
			set = "SetPartyframe",
			order = 2,
		},
		
		Raid = {
			type = "text",
			name = "Raid Frame",
			desc = "Select which Raid frame support to use",
			validate = {"Blizzard", "XPerl", "Ag_UnitFrames"},
			get = "GetRaidframe",
			set = "SetRaidframe",
			order = 3,
		},
		
		Raidnumber = {
			type = "range",
			name = "Raid Group",
			desc = "Set raid display group",
			min = 0, 
			max = 8, 
			step = 1,
			get = "GetRaid",
			set = "SetRaid",
			order = 4
		},
		
		RaidSelect = {
			name = "Auto raid select",
			desc = "Auto select raid group",
			type = "toggle",
			get = "GetAutoSelect",
			set = "SetAutoSelect",
			map = {[false] = L["Off"], [true] = L["On"]},
			order = 5
		},
		
		Spacing = {
			name = " ",
			type = "header",
			order = 6
		},
		

		[L["resetplayer"]] = {
			name = "Reset Player",
			desc = L["Reset player buttons to the default positions."],
			type = "execute",
			func = "ResetPlayerSavedLocation",
			order = 7
		},
		
		resetparty = {
			name = "Reset Party",
			desc = "Reset player buttons to the default positions.",
			type = "execute",
			func = "ResetPartySavedLocation",
			order = 8
		},
		
		resetraid = {
			name = "Reset Raid",
			desc = "Reset player buttons to the default positions.",
			type = "execute",
			func = "ResetRaidSavedLocation",
			order = 9
		},
		
		[L["reset"]] = {
			name = "Reset all",
			desc = L["Reset buttons to the default positions."],
			type = "execute",
			func = "ResetConfigSavedLocation",
			order = 10
		},
		
		Spacing1 = {
			name = " ",
			type = "header",
			order = 11
		},
		
		number = {
			name = "Button number",
			desc = "Set how many buttons should appear for each character frame",
			type = "range", 
			min = 1, 
			max = 4, 
			step = 1,
			get = "GetButtonCount",
			set = "SetButtonCount",
			order = 12
		},
		
		[L["size"]] = {
			name = L["size"], 
			desc = L["Set the height and width of each button."],
			type = "range", 
			min = 10, 
			max = 80, 
			step = 1,
			get = "GetButtonSize",
			set = "SetButtonSize",
		order = 13
		},

		Spacing2 = {
			name = " ",
			type = "header",
			order = 14
		},
		
		[L["tooltips"]] = {
			name = "Show tooltips",
			desc = L["Toggle whether buttons show tooltips on mouseover."],
			type = "toggle",
			get = "GetShowTooltips",
			set = "SetShowTooltips",
			map = {[false] = L["Off"], [true] = L["On"]},
			order = 15
		},
		
		[L["anchor"]] = {
			name = "Tooltip anchor", 
			desc = L["Specify how tooltips are anchored to their parent button."],
			type = "text",
			get = "GetTooltipAnchor",
			set = "SetTooltipAnchor",
			validate = { ["TOPLEFT"] = L["TopLeft"], ["TOP"] = L["Top"], ["TOPRIGHT"] = L["TopRight"],
						 ["BOTTOMLEFT"] = L["BottomLeft"], ["BOTTOM"] = L["Bottom"], ["BOTTOMRIGHT"] = L["BottomRight"],
						 ["LEFT"] = L["Left"], ["RIGHT"] = L["Right"], ["CURSOR"] = L["Cursor"] },
			order = 16
		},
		
		[L["movable"]] = {
			name = L["movable"],
			desc = L["Toggle whether buttons can be moved by dragging."],
			type = "toggle",
			get = "GetMovable",
			set = "SetMovable",
			map = {[false] = L["Off"], [true] = L["On"]},
			order = 17
		},
		
		[L["pets"]] = {
			name = "Show pets",
			desc = L["Toggle whether buttons are shown for party member pets."],
			type = "toggle",
			get = "GetShowPetButtons",
			set = "SetShowPetButtons",
			map = {[false] = L["Off"], [true] = L["On"]},
			order = 18
		},
		
		debugs = {
			name = "Debug",
			desc = "Report when try to draw on hidden or none existing frames",
			type = "toggle",
			get = "GetDebug",
			set = "SetDebug",
			map = {[false] = L["Off"], [true] = L["On"]},
			order = 19
		},
		
		
	},
}

HealerButtons.independentProfile = false
HealerButtons.OnMenuRequest = menu
HealerButtons.hasIcon = true
HealerButtons.defaultMinimapPosition = 200
HealerButtons.cannotDetachTooltip = true
HealerButtons.defaultPosition = "LEFT"
HealerButtons.hideWithoutStandby = true

HealerButtons.options = { 
	type = "group",
	args = {

		[L["Raid"]] = {
			name = L["Raid Group"],
			desc = L["Set Which raid group to display, 0 = disabled"],
			type = "range", 
			min = 0, 
			max = 8, 
			step = 1,
			get = "GetRaid",
			set = "SetRaid"
		},

		[L["bind"]] = {
			name = L["bind"], 
			desc = L["Bind a spell or bandage to the mouse click of a button."],
			usage = "nc <spell | bandage | none>\nOptions:\n     n - button number 1, 2, 3 or 4 \n     c - click l, r, or m\nExamples:\n     1l Lesser Heal  -  assigns Lesser Heal to the left click of button 1\n     1l Bandage  -  assigns best bandage to the left click of button 1\n     2r Linen Bandage  -  assigns Linen Bandage to the right click of button 2\n     2r none  -  clears the assignment of the right click of button 2",
			type = "text",
			input = true,
			get = false,
			set = "SetBinding",
			validate = "VerifyBinding"
		}
    }
}

HealerButtons.PreferenceDefaults = {
	playerframe			= "Blizzard",
	Partyframe			= "Blizzard",
	Raidframe			= "Blizzard",
	ShowTooltips		= true,
	TooltipAnchor		= "CURSOR",
	Movable				= true,
	Debug				= false,
	ShowPetButtons		= true,
	AutoSelect 			= true,
	ButtonCount			= 3,
	raid				= 2,
	ButtonSize = { 18, 18 },
	ButtonLocs = {
		player		= {0, 0, 20, 0, 40, 0, 60, 0},
		party1		= {0, 0, 20, 0, 40, 0, 60, 0},
		party2		= {0, 0, 20, 0, 40, 0, 60, 0},
		party3		= {0, 0, 20, 0, 40, 0, 60, 0},
		party4		= {0, 0, 20, 0, 40, 0, 60, 0},
		partypet1	= {0, 0, 20, 0, 40, 0, 60, 0},
		partypet2	= {0, 0, 20, 0, 40, 0, 60, 0},
		partypet3	= {0, 0, 20, 0, 40, 0, 60, 0},
		partypet4	= {0, 0, 20, 0, 40, 0, 60, 0},
		raid1		= {0, 0, 20, 0, 40, 0, 60, 0},
		raid2		= {0, 0, 20, 0, 40, 0, 60, 0},
		raid3		= {0, 0, 20, 0, 40, 0, 60, 0},
		raid4		= {0, 0, 20, 0, 40, 0, 60, 0},
		raid5		= {0, 0, 20, 0, 40, 0, 60, 0}
	},
	SpellTable = {
		Priest = {
			Name = {
				L["Flash Heal"], L["Power Word: Shield"], "", L["Greater Heal"], L["Heal"], "", L["Renew"], "", ""
			},
			Type = {
				"SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL"
			}
		},
		Shaman = {
			Name = {
				L["Healing Wave"], L["Lesser Healing Wave"], "", L["Chain Heal"], L["Ancestral Spirit"], "", L["Cure Disease"], L["Cure Poison"], ""
			},
			Type = {
				"SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL"
			}
		},
		Druid = {
			Name = {
				L["Healing Touch"], L["Rejuvenation"], "", L["Rebirth"], L["Abolish Poison"], L["Cure Poison"], L["Regrowth"], L["Remove Curse"], ""
			},
			Type = {
				"SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL"
			}
		},
		Paladin = {
			Name = {
				L["Flash of Light"], "", "", L["Holy Light"], "", "", L["Cleanse"], "", ""
			},
			Type = {
				"SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL","SPELL"
			}
		}
	}
}

HealerButtons:RegisterDB("Preferences")
HealerButtons:RegisterDefaults("profile", HealerButtons.PreferenceDefaults)

function HealerButtons:OnClick()
self:ResetButtons()
end

function HealerButtons:OnInitialize(name)

	self.Class = self:UnitClass("player")
	self.CanChangeButtons = true

	if (self:IsHealerClass()) then
		self:RegisterChatCommand(L["Slash-Commands"], HealerButtons.options)
	else
		self:RegisterChatCommand(L["Slash-Commands"])
	end
end

function HealerButtons:OnEnable(first)
	if self:IsHealerClass() then
		self:RegisterEvent("PARTY_MEMBERS_CHANGED")
		self:RegisterEvent("UNIT_PET")
		self:RegisterEvent("BAG_UPDATE")
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		self:RegisterEvent("PLAYER_REGEN_DISABLED")
		self:RegisterEvent("RAID_ROSTER_UPDATE")
		self:GetBandages()
		self:SetupButtons()
    end
end

function HealerButtons:OnDisable()
	if self:IsHealerClass() then
		self:HideButtons("player", "")
		for i = 1,4 do
			self:HideButtons("party", i)
			self:HideButtons("partypet", i)
		end                
	end
end

function HealerButtons:OnProfileEnable()
	self:GetBandages()
	self:SetupButtons()
end

function HealerButtons:PARTY_MEMBERS_CHANGED()
		self:SetupButtons()
end

function HealerButtons:RAID_ROSTER_UPDATE()
		self:SetupButtons()
end

function HealerButtons:UNIT_PET()
	if self.CanChangeButtons then
		self:SetupButtons()
	end
end

function HealerButtons:BAG_UPDATE()
	if self.CanChangeButtons then
		self:GetBandages()
		self:SetupButtons()
	end
end

function HealerButtons:PLAYER_REGEN_ENABLED()
	self.CanChangeButtons = true
	self:SetupButtons()   
end

function HealerButtons:PLAYER_REGEN_DISABLED()
	self.CanChangeButtons = false
end

function HealerButtons:SetupButtons()
	if UnitAffectingCombat("player") then
	return false
	end
	

	self:AttachSpells("player", "Player", "")
	local PartyCount = GetNumPartyMembers()
	local raidCount = GetNumRaidMembers()
	raidCount = raidCount - PartyCount
	raidCount = raidCount - 1
	
	for i = 1,4 do
	   if (PartyCount >= i) then 
			self:AttachSpells("party", "PartyMember", i)
			if (self.db.profile.ShowPetButtons and UnitExists("partypet" .. i)) then
				self:AttachSpells("partypet","PartyMember",i)
			else
				self:HideButtons("partypet",i)
			end
		else 
			self:HideButtons("party",i)
			self:HideButtons("partypet",i)
		end                
	end 
	 
	for i = 1,5 do
	   if (raidCount >= i) then 
			self:AttachSpells("raid", "raidMember", i)
		else 
			self:HideButtons("raid",i)
		end                
	end  
end

function HealerButtons:ShowButtons(frame, framenumber)
	if UnitAffectingCombat("player") then
	return false
	end
	local button1 = getglobal("HB_" .. frame .. framenumber .. "Button1")
	local button2 = getglobal("HB_" .. frame .. framenumber .. "Button2")
	local button3 = getglobal("HB_" .. frame .. framenumber .. "Button3")
	local button4 = getglobal("HB_" .. frame .. framenumber .. "Button4")
    button1:Show()
    if (self.db.profile.ButtonCount > 1) then 
        button2:Show()
    else
        button2:Hide()
    end
    if (self.db.profile.ButtonCount > 2) then 
        button3:Show()
    else
        button3:Hide()
    end
    if (self.db.profile.ButtonCount > 3) then 
        button4:Show()
    else
        button4:Hide()
    end
end

function HealerButtons:HideButtons(frame, framenumber)
	if UnitAffectingCombat("player") then
	return false
	end
	local button1 = getglobal("HB_" .. frame .. framenumber .. "Button1")
	local button2 = getglobal("HB_" .. frame .. framenumber .. "Button2")
	local button3 = getglobal("HB_" .. frame .. framenumber .. "Button3")
	local button4 = getglobal("HB_" .. frame .. framenumber .. "Button4")
    button1:Hide()
    button2:Hide()
    button3:Hide()
    button4:Hide()
end


function HealerButtons:AttachSpells(frame,frametype,framenumber)
	if UnitAffectingCombat("player") then
	return false
	end
	

	local button1 = getglobal("HB_" .. frame .. framenumber .. "Button1")
	local button2 = getglobal("HB_" .. frame .. framenumber .. "Button2")
	local button3 = getglobal("HB_" .. frame .. framenumber .. "Button3")
	local button4 = getglobal("HB_" .. frame .. framenumber .. "Button4")
	local framename = frametype .. "Frame" .. framenumber
	
	if (string.find(frametype,"Player")) then
		if (self:GetPlayerframe() == "Ag_UnitFrames") then
			framename = "aUFplayer"
			else if (self:GetPlayerframe() == "XPerl") then
				framename = "XPerl_Player"
			else if (self:GetPlayerframe() == "Blizzard") then
			    framename = "PlayerFrame"
			end
		end
	end
	end
	
	if (string.find(frame,"partypet")) then
		if (self:GetPartyframe() == "Ag_UnitFrames") then
				framename = "aUFpartypetUnitButton" .. framenumber
			else if (self:GetPartyframe() == "XPerl") then
				framename = "XPerl_partypet" .. framenumber .. "nameFrame"
			else if (self:GetPartyframe() == "Blizzard") then
			    framename = "PartyMemberFrame" .. framenumber .. "PetFrame"
			end
		end
	end
	else	
	if (string.find(frametype,"PartyMember")) then
		if (self:GetPartyframe() == "Ag_UnitFrames") then
				framename = "aUFpartyUnitButton" .. framenumber
			else if (self:GetPartyframe() == "XPerl") then
				framename = "XPerl_party" .. framenumber
			else if (self:GetPartyframe() == "Blizzard") then
			    framename = "PartyMemberFrame" .. framenumber
			end
		end
	end
	end
	end
	
	if (string.find(frametype,"raidMember")) then
		if (self:GetRaid() > 0) then
		if (self:GetAutoSelect()) then
		for i = 1,10 do
			local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i);
			local pname = UnitName("player")
				if (pname == name) then
					if (subgroup == 1 and self:GetRaid() == 1) then
						print("Healers Buttons: Switching raid group to 2")
					self:SetRaid(2)
					else if (subgroup == 2 and self:GetRaid() == 2) then
						print("Healers Buttons: Switching raid group to 1")
					self:SetRaid(1)
					end
				end
			end
			end		
		end
		
		
			if (self:GetRaidframe() == "Ag_UnitFrames") then
								framename = "aUFgroup" .. self:GetRaid() .. "UnitButton" .. framenumber
				else if (self:GetRaidframe() == "XPerl") then
					framename = "XPerl_Raid_Grp" .. self:GetRaid() .. "UnitButton" .. framenumber
				else if (self:GetRaidframe() == "Blizzard") then
				    framename = "RaidPullout" .. self:GetRaid() .. "Button" .. framenumber .. "ClearButton"
			end
			end
			end
	
			local counter = 0
			local tarframe = getglobal(framename)
			if (tarframe ~= nil) then
			while (true) do 
	            if (tarframe:GetAttribute("unit")) then
	            if (counter ~= 0) then
	            print("Count: " .. counter)
	            end
			        local tarname =  UnitName(tarframe:GetAttribute("unit"))
					button1:SetAttribute("unit", tarname)
					button2:SetAttribute("unit", tarname)
					button3:SetAttribute("unit", tarname)
					button4:SetAttribute("unit", tarname)
	            	break
	            end
	            
	            if (counter == 100) then
	            break
	            end
	            counter = counter + 1
	        end  

			else
			if (self:GetDebug()) then
			print("Healers Buttons: " .. framename .. " not found")
			end
			return
			end
		else
		return
		end
	end

	if (getglobal(framename) ~= nil) then
	button1:SetPoint("TOPLEFT", framename, "TOPRIGHT", self.db.profile.ButtonLocs[frame .. framenumber][1], self.db.profile.ButtonLocs[frame .. framenumber][2])
	button2:SetPoint("TOPLEFT", framename, "TOPRIGHT", self.db.profile.ButtonLocs[frame .. framenumber][3], self.db.profile.ButtonLocs[frame .. framenumber][4])
	button3:SetPoint("TOPLEFT", framename, "TOPRIGHT", self.db.profile.ButtonLocs[frame .. framenumber][5], self.db.profile.ButtonLocs[frame .. framenumber][6])
	button4:SetPoint("TOPLEFT", framename, "TOPRIGHT", self.db.profile.ButtonLocs[frame .. framenumber][7], self.db.profile.ButtonLocs[frame .. framenumber][8])
	else
	print("Healers Buttons: " .. framename .. " not found")
	return
	end
	
	for i = 1,4 do
		self:SetButton(button1, i, i)
		self:SetButton(button2, i+3, i)
		self:SetButton(button3, i+6, i)
		self:SetButton(button4, i+9, i)
	end
	
	local tarframe = getglobal(framename)
	if (tarframe ~= nil) then
	if (tarframe:IsVisible() and tarframe:IsShown()) then
	self:ShowButtons(frame, framenumber)
	else
	if (string.find(framename, "pet") and string.find(frametype,"raidMember")) then
	else
		if (msg ~= framename and self:GetDebug()) then
		print("Healer Buttons: " .. framename .. " is not visible buttons won't be drawn")
		msg = framename
		self:HideButtons(frame, framenumber)
		end
	end
	end
	else
	if (string.find(frametype,"raidMember")) then
		if (msg ~= framename and self:GetDebug()) then
		print("Healer Buttons: " .. framename .. " not found")
		msg = framename
		end
	else
	end
	end
end

function HealerButtons:SetButton(button, index, click)
	if UnitAffectingCombat("player") then
	return false
	end
	button:SetHeight(self.db.profile.ButtonSize[1])
	button:SetWidth(self.db.profile.ButtonSize[2])
	
	if (self.db.profile.SpellTable[self.Class].Type[index] == "BANDAGE") then
		button:SetAttribute("HBType" .. click, "BANDAGE")
		button:SetAttribute("HBName" .. click, self.db.profile.SpellTable[self.Class].Name[index])
		button:SetAttribute("type" .. click, "item")

		local bandageName = self.db.profile.SpellTable[self.Class].Name[index]
		if (string.lower(bandageName) == "bandage") then 
			button:SetAttribute("HBName" .. click, L["Bandage"])
			bandageName = self:GetBestBandage()
		end        
		button:SetAttribute("item"..click, bandageName)
		
		if (click == 1) then
			self:SetItemButtonTexture(button, bandageName)
		end
	else
		button:SetAttribute("HBType" .. click, "SPELL")
		button:SetAttribute("HBName" .. click, self.db.profile.SpellTable[self.Class].Name[index])
		button:SetAttribute("type" .. click, "spell")
		button:SetAttribute("spell" .. click, self.db.profile.SpellTable[self.Class].Name[index])
		
		local name = button:GetName();

		if (click == 1) then
			self:SetSpellButtonTexture(button, self.db.profile.SpellTable[self.Class].Name[index])
		end
	end
end

function HealerButtons:IsBandage(name)
	return(string.lower(name) == "bandage" or self.bandageInfo[name] ~= nil)
end

function print(Text)
	DEFAULT_CHAT_FRAME:AddMessage(Text);
end


function HealerButtons:GetBandages()
    self.bandageInfo[self.bandages.Linen].OnHand = 0
    self.bandageInfo[self.bandages.HeavyLinen].OnHand = 0
    self.bandageInfo[self.bandages.Wool].OnHand = 0
    self.bandageInfo[self.bandages.HeavyWool].OnHand = 0
    self.bandageInfo[self.bandages.Silk].OnHand = 0
    self.bandageInfo[self.bandages.HeavySilk].OnHand = 0
    self.bandageInfo[self.bandages.Mageweave].OnHand = 0
    self.bandageInfo[self.bandages.HeavyMageweave].OnHand = 0
    self.bandageInfo[self.bandages.Runecloth].OnHand = 0
    self.bandageInfo[self.bandages.HeavyRunecloth].OnHand = 0
    self.bandageInfo[self.bandages.Netherweave].OnHand = 0
    self.bandageInfo[self.bandages.HeavyNetherweave].OnHand = 0

    local bag, slot, itemLink, itemName
    local bandageBag = -1
    local bandageSlot = -1
    local healTotal = -1

    for bag = 0,4 do
        for slot = 1,GetContainerNumSlots(bag) do
            itemLink = GetContainerItemLink(bag, slot)
            if itemLink then
                local _, itemCount = GetContainerItemInfo(bag, slot)
                _, _, itemName = string.find(itemLink, "%[(.*)%]")
                if (itemName and self.bandageInfo[itemName]) then
                    self.bandageInfo[itemName].OnHand = itemCount
                    self.bandageInfo[itemName].Bag = bag
                    self.bandageInfo[itemName].Slot = slot
                end
            end
        end
    end
end

function HealerButtons:GetBestBandage()
    local zone = GetZoneText()
    
    if string.find(zone, L["Alterac Valley"]) then 
        if (self.bandageInfo[self.bandages.HeavyRunecloth].OnHand > 0) then 
            return self.bandages.AVHeavyRunecloth
        end
    elseif string.find(zone, L["Arathi Basin"]) then 
        if (self.bandageInfo[self.bandages.HighlandersRunecloth].OnHand > 0) then
            return self.bandages.HighlandersRunecloth
        elseif (self.bandageInfo[self.bandages.HighlandersMageweave].OnHand > 0) then
            return self.bandages.HighlandersMageweave
        elseif (self.bandageInfo[self.bandages.HighlandersSilk].OnHand > 0) then
            return self.bandages.HighlandersSilk
        elseif (self.bandageInfo[self.bandages.DefilersRunecloth].OnHand > 0) then
            return self.bandages.DefilersRunecloth
        elseif (self.bandageInfo[self.bandages.DefilersMageweave].OnHand > 0) then
            return self.bandages.DefilersMageweave
        elseif (self.bandageInfo[self.bandages.DefilersSilk].OnHand > 0) then
            return self.bandages.DefilersSilk
        elseif (self.bandageInfo[self.bandages.ABRunecloth].OnHand > 0) then
            return self.bandages.ABRunecloth
        elseif (self.bandageInfo[self.bandages.ABMageweave].OnHand > 0) then
            return self.bandages.ABMageweave
        elseif (self.bandageInfo[self.bandages.ABSilk].OnHand > 0) then
            return self.bandages.ABSilk
        end
    elseif string.find(zone, L["Warsong Gulch"]) then 
        if (self.bandageInfo[self.bandages.WSGRunecloth].OnHand > 0) then
            return self.bandages.WSGRunecloth
        elseif (self.bandageInfo[self.bandages.WSGMageweave].OnHand > 0) then
            return self.bandages.WSGMageweave
        elseif (self.bandageInfo[self.bandages.WSGSilk].OnHand > 0) then
            return self.bandages.WSGSilk
        end
    end
    if (self.bandageInfo[self.bandages.HeavyNetherweave].OnHand > 0) then
        return self.bandages.HeavyNetherweave
    elseif (self.bandageInfo[self.bandages.Netherweave].OnHand > 0) then
        return self.bandages.Netherweave
    elseif (self.bandageInfo[self.bandages.HeavyRunecloth].OnHand > 0) then
        return self.bandages.HeavyRunecloth
    elseif (self.bandageInfo[self.bandages.Runecloth].OnHand > 0) then
        return self.bandages.Runecloth
    elseif (self.bandageInfo[self.bandages.HeavyMageweave].OnHand > 0) then 
        return self.bandages.HeavyMageweave
    elseif (self.bandageInfo[self.bandages.Mageweave].OnHand > 0) then
        return self.bandages.Mageweave
    elseif (self.bandageInfo[self.bandages.HeavySilk].OnHand > 0) then
        return self.bandages.HeavySilk
    elseif (self.bandageInfo[self.bandages.Silk].OnHand > 0) then
        return self.bandages.Silk
    elseif (self.bandageInfo[self.bandages.HeavyWool].OnHand > 0) then
        return self.bandages.HeavyWool
    elseif (self.bandageInfo[self.bandages.Wool].OnHand > 0) then
        return self.bandages.Wool
    elseif (self.bandageInfo[self.bandages.HeavyLinen].OnHand > 0) then 
        return self.bandages.HeavyLinen
    elseif (self.bandageInfo[self.bandages.Linen].OnHand > 0) then
        return self.bandages.Linen
    else 
        return "NONE"
    end
end

function HealerButtons:UnitClass(unit)    
	local class
	if UnitClass(unit) == L["Priest"] then 
		class = "Priest"
	elseif UnitClass(unit) == L["Druid"] then 
		class = "Druid"
	elseif UnitClass(unit) == L["Paladin"] then 
		class = "Paladin"
	elseif UnitClass(unit) == L["Shaman"] then
		class = "Shaman"
	end
	return class
end

function HealerButtons:IsHealerClass()
	return(self.Class == "Priest" or self.Class == "Paladin" or self.Class == "Druid" or self.Class == "Shaman")
end

function HealerButtons:MakeTooltip(button)
    if (self.db.profile.ShowTooltips) then
		GameTooltip:SetOwner(button, "ANCHOR_NONE")
        if (self.db.profile.TooltipAnchor == "TOPLEFT") then
            GameTooltip:SetPoint("BOTTOMRIGHT", button, "TOPLEFT")
        elseif (self.db.profile.TooltipAnchor == "TOP") then
            GameTooltip:SetPoint("BOTTOM", button, "TOP")
        elseif (self.db.profile.TooltipAnchor == "TOPRIGHT") then
            GameTooltip:SetPoint("BOTTOMLEFT", button, "TOPRIGHT")
        elseif (self.db.profile.TooltipAnchor == "BOTTOMLEFT") then
            GameTooltip:SetPoint("TOPRIGHT", button, "BOTTOMLEFT")
        elseif (self.db.profile.TooltipAnchor == "BOTTOM") then
            GameTooltip:SetPoint("TOP", button, "BOTTOM")
        elseif (self.db.profile.TooltipAnchor == "BOTTOMRIGHT") then
            GameTooltip:SetPoint("TOPLEFT", button, "BOTTOMRIGHT")
        elseif (self.db.profile.TooltipAnchor == "LEFT") then
            GameTooltip:SetPoint("RIGHT", button, "LEFT")
        elseif (self.db.profile.TooltipAnchor == "RIGHT") then
            GameTooltip:SetPoint("LEFT", button, "RIGHT")
        else
			GameTooltip:SetOwner(button, "ANCHOR_CURSOR")
        end

        if (string.find(button:GetName(), "Button1") ) then
        	GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE .. L["Button"] .. " " .. 1)
        elseif (string.find(button:GetName(), "Button2") ) then
        	GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE .. L["Button"] .. " " .. 2)
        elseif (string.find(button:GetName(), "Button3") ) then
        	GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE .. L["Button"] .. " " .. 3)
        elseif (string.find(button:GetName(), "Button4") ) then
        	GameTooltip:AddLine(HIGHLIGHT_FONT_COLOR_CODE .. L["Button"] .. " " .. 4)
		end

        if (string.len(button:GetAttribute("HBName1")) > 0 and not (string.lower(button:GetAttribute("HBName1")) == "none") ) then 
            GameTooltip:AddLine(NORMAL_FONT_COLOR_CODE .. L["Left: "] .. LIGHTYELLOW_FONT_COLOR_CODE .. button:GetAttribute("HBName1"))
        end

        if (string.len(button:GetAttribute("HBName2")) > 0 and not (string.lower(button:GetAttribute("HBName2")) == "none") ) then 
            GameTooltip:AddLine(NORMAL_FONT_COLOR_CODE .. L["Right: "] .. LIGHTYELLOW_FONT_COLOR_CODE .. button:GetAttribute("HBName2"))
        end

        if button:GetAttribute("HBName3") ~= nil then
	        if (string.len(button:GetAttribute("HBName3")) > 0 and not (string.lower(button:GetAttribute("HBName3")) == "none") ) then 
	            GameTooltip:AddLine(NORMAL_FONT_COLOR_CODE .. L["Middle: "] .. LIGHTYELLOW_FONT_COLOR_CODE .. button:GetAttribute("HBName3"))
	        end
		end
	      
        GameTooltip:Show()
    end
end



function HealerButtons:ResetButtons()
	self:SetupButtons()
	print("Healer Buttons: All icons have been redraw!")
end	

function HealerButtons:ResetConfigSavedLocation()
   local fromWhich = HealerButtons.PreferenceDefaults.ButtonLocs
   for i = 1,8 do
       self.db.profile.ButtonLocs.player[i] = fromWhich.player[i]
       for j = 1,4 do
           local party = "party" .. j
           local partypet = "partypet" .. j
           self.db.profile.ButtonLocs[party][i] = fromWhich[party][i]
           self.db.profile.ButtonLocs[partypet][i] = fromWhich[partypet][i]
       end
   end
   self:SetupButtons()
   self:Print(L["Buttons have been reset to the default positions."])
end

function HealerButtons:ResetPlayerSavedLocation()
local fromWhich = HealerButtons.PreferenceDefaults.ButtonLocs
   for i = 1,8 do
       self.db.profile.ButtonLocs.player[i] = fromWhich.player[i]
   end
   self:SetupButtons()
   self:Print(L["Player Buttons have been reset to the default positions."])
end

function HealerButtons:ResetPlayerSavedLocation()
local fromWhich = HealerButtons.PreferenceDefaults.ButtonLocs
   for i = 1,8 do
       self.db.profile.ButtonLocs.player[i] = fromWhich.player[i]
   end
   self:SetupButtons()
   self:Print(L["Player Buttons have been reset to the default positions."])
end

function HealerButtons:ResetPartySavedLocation()
local fromWhich = HealerButtons.PreferenceDefaults.ButtonLocs

for i = 1,8 do
       for j = 1,4 do
           local party = "party" .. j
           local partypet = "partypet" .. j
           self.db.profile.ButtonLocs[party][i] = fromWhich[party][i]
           self.db.profile.ButtonLocs[partypet][i] = fromWhich[partypet][i]
       end
end
   self:SetupButtons()
   self:Print(L["Party Buttons have been reset to the default positions."])
end

function HealerButtons:ResetRaidSavedLocation()
local fromWhich = HealerButtons.PreferenceDefaults.ButtonLocs

for i = 1,8 do
	for x = 1,5 do
       local raid = "raid" .. x
       self.db.profile.ButtonLocs[raid][i] = fromWhich[raid][i]
   end
end
   self:SetupButtons()
   self:Print(L["Raid Buttons have been reset to the default positions."])
end

function HealerButtons:Points(button, name, offset)
	if (string.find(name, "party1")) then
		name = "party1"
	elseif (string.find(name, "party2")) then
		name = "party2"
	elseif (string.find(name, "party3")) then
		name = "party3"
	elseif (string.find(name, "party4")) then
		name = "party4"
	elseif (string.find(name, "partypet1")) then
		name = "partypet1"
	elseif (string.find(name, "partypet2")) then
		name = "partype21"
	elseif (string.find(name, "partypet3")) then
		name = "partypet3"
	elseif (string.find(name, "partypet4")) then
		name = "partypet4"
	elseif (string.find(name, "raid1")) then
		name = "raid1"
	elseif (string.find(name, "raid2")) then
		name = "raid2"
	elseif (string.find(name, "raid3")) then
		name = "raid3"
	elseif (string.find(name, "raid4")) then
		name = "raid4"
	elseif (string.find(name, "raid5")) then
		name = "raid5"
	else
		name = "player"
	end
	
	local x = self.db.profile.ButtonLocs[name][offset + 1] - (self.ButtonNow[1] - button:GetLeft())
	local y = self.db.profile.ButtonLocs[name][offset + 2] - (self.ButtonNow[2] - button:GetTop())

	
	
	return name, x, y
end

function HealerButtons:OnDragStart(button)
	if (self.db.profile.Movable and not self.BeingDragged) then
        self.ButtonNow = { button:GetLeft(), button:GetTop() }
		button:StartMoving()
		self.BeingDragged = true
	end
end

function HealerButtons:OnDragStop(button)
    local name = button:GetName()
    local x
    local y
    local height = button:GetHeight()
    local offset = 0

	if (self.BeingDragged) then
		button:StopMovingOrSizing()
		self.BeingDragged = false
        if (string.find(name, "Button1")) then
            offset = 0
        elseif (string.find(name, "Button2")) then
            offset = 2
        elseif (string.find(name, "Button3")) then
            offset = 4
        else 
            offset = 6
        end

        name, x, y = self:Points(button, name, offset)
        
        self.db.profile.ButtonLocs[name][offset + 1] = x
        self.db.profile.ButtonLocs[name][offset + 2] = y
	end
end

function HealerButtons:SetSpellButtonTexture(button, spellNameMatch)
	local i = 1
	while (true) do
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
		if (not spellName) then
			button:SetNormalTexture("Interface\\Icons\\INV_Misc_QuestionMark")
			do break end
		elseif (spellName == spellNameMatch) then
			local texture = GetSpellTexture(i, BOOKTYPE_SPELL)
			button:SetNormalTexture(texture)
			do break end
		end
		i = i + 1
	end
end

function HealerButtons:SetItemButtonTexture(button, itemNameMatch)
    local _, bag, slot, itemLink, itemName, texture
    for bag=0,4 do
        for slot=1, GetContainerNumSlots(bag) do
            itemLink = GetContainerItemLink(bag, slot)
            if (itemLink) then
                _, _, itemName = string.find(itemLink, "%[(.*)%]")
				if (itemName == itemNameMatch) then
					texture, _, _, _, _ = GetContainerItemInfo(bag, slot)
					button:SetNormalTexture(texture)
					return
                end
            end
        end
    end
end

function HealerButtons:GetButtonIndex(code, button, click)
	local index = -1
	code = string.lower(code)
	if code == "1r" or (button == 1 and click == "RightButton") then    
		index = 2
	elseif code == "1m" or (button == 1 and click == "MiddleButton") then
		index = 3
	elseif code == "1l" or (button == 1 and click == "LeftButton") then
		index = 1
	elseif code == "2r" or (button == 2 and click == "RightButton") then
		index = 5
	elseif code == "2m" or (button == 2 and click == "MiddleButton") then
		index = 6
	elseif code == "2l" or (button == 2 and click == "LeftButton") then
		index = 4
	elseif code == "3r" or (button == 3 and click == "RightButton") then
		index = 8
	elseif code == "3m" or (button == 3 and click == "MiddleButton") then
		index = 9
	elseif code == "3l" or (button == 3 and click == "LeftButton") then
		index = 7
	elseif code == "4r" or (button == 4 and click == "RightButton") then
		index = 11
	elseif code == "4m" or (button == 4 and click == "MiddleButton") then
		index = 12
	elseif code == "4l" or (button == 4 and click == "LeftButton") then
		index = 10
	end
	return index
end

function HealerButtons:SetBinding(code, n1, n2, n3)
    local index = self:GetButtonIndex(code)
    if (index > 0) then
		local spellname = n1
		if n2 then
			spellname = spellname .. " " .. n2
		end
		if n3 then
			spellname = spellname .. " " .. n3
		end

        self.db.profile.SpellTable[self.Class].Name[index] = spellname
        
        if self:IsBandage(spellname) then
            self.db.profile.SpellTable[self.Class].Type[index] = "BANDAGE"
        else
            self.db.profile.SpellTable[self.Class].Type[index] = "SPELL"
        end
        
        self:SetupButtons()
        self:Print(code .. L[" button has been set to: "] .. spellname)
    end
end

function HealerButtons:VerifyBinding(code)    
	return(self:GetButtonIndex(code) > 0)
end

function HealerButtons:GetButtonCount()
	return self.db.profile.ButtonCount
end

function HealerButtons:SetButtonCount(v)
	self.db.profile.ButtonCount = v
	self:SetupButtons()
end

function HealerButtons:GetButtonSize()
	return self.db.profile.ButtonSize[1]
end

function HealerButtons:SetButtonSize(v)
	self.db.profile.ButtonSize = { math.min(v), math.min(v) }
	self:SetupButtons()
end

function HealerButtons:GetMovable()
	return self.db.profile.Movable
end

function HealerButtons:SetMovable(v)
	self.db.profile.Movable = v
end

function HealerButtons:GetShowPetButtons()
	return self.db.profile.ShowPetButtons
end

function HealerButtons:SetShowPetButtons(v)
	self.db.profile.ShowPetButtons = v
end

function HealerButtons:GetShowTooltips()
	return self.db.profile.ShowTooltips
end

function HealerButtons:SetShowTooltips(v)
	self.db.profile.ShowTooltips = v
end

function HealerButtons:GetTooltipAnchor()
	return self.db.profile.TooltipAnchor
end

function HealerButtons:SetTooltipAnchor(v)
	self.db.profile.TooltipAnchor = v
end

function HealerButtons:GetRaid()
	return self.db.profile.raid
end

function HealerButtons:SetRaid(v)
	self.db.profile.raid = v
	if (v == 0) then
	print("Healer Buttons: Raid group display disabled")
	else
	print("Healer Buttons: Displaying raid group " .. v .. " on " .. self:GetRaidframe())
	end
	self:SetupButtons()
end

function HealerButtons:GetPlayerframe()
	return self.db.profile.Playerframe
end

function HealerButtons:SetPlayerframe(v)
	self.db.profile.Playerframe = v
	self:SetupButtons()
end

function HealerButtons:GetPartyframe()
	return self.db.profile.Partyframe
end

function HealerButtons:SetPartyframe(v)
	self.db.profile.Partyframe = v
	self:SetupButtons()
end

function HealerButtons:GetRaidframe()
	return self.db.profile.Raidframe
end

function HealerButtons:SetRaidframe(v)
	self.db.profile.Raidframe = v
	self:SetupButtons()
end

function HealerButtons:GetAutoSelect()
	return self.db.profile.AutoSelect
end

function HealerButtons:SetAutoSelect(v)
	self.db.profile.AutoSelect = v
end

function HealerButtons:GetDebug()
	return self.db.profile.Debug
end

function HealerButtons:SetDebug(v)
	self.db.profile.Debug = v
end